/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


import java.util.Random;

/**
 *
 * @author Luis Eduardo Pavón and Luis Merino
 */
public class Bacteria implements IBacteria {

     /* Aumento concentración cuando attached en la pared vegetal (mol/seg.)*/
    public static double REACTION_SPEED;

    private double ultimaConcentracion;
    private double probabilidadCarrera;

    private double intervaloCarrera;
    private double tiempoActual;
    /*Tamaño maximo del medio*/
    private int m;
    private int n;
    /*Posicion actual*/
    private int x;
    private int y;

    /*Values: 1, attached to vegetal cell. 0, no attached*/
    private int attached;

    private double probabilidadAttachment;

    /*Velocidad media (m/s)*/
    private double v;

    /*Tamaño de celda (m/celda)*/
    private double cellSize;

    /*Proximo movimiento*/
    private int movimientoX;
    //{-1, 0, 1} dependiendo de si el proximo movimiento será a la {izquierda, centro, derecha}
    private int movimientoY;
    //{-1, 0, 1} dependiendo de si el proximo movimiento será a la {arriba, centro, abajo}

    public Bacteria(int m, int n, int x, int y, double concentracion, double tam, double reactionSpeed) {
        this.REACTION_SPEED = reactionSpeed;
        setM(m);
        setN(n);
        setX(x);
        setY(y);
        setUltimaConcentracion(concentracion);
        cellSize=tam;
        /*Speed in cells/seg*/
        v=cellSize*10;
        /*v=ECHOLI_SPEED/cellSize*/
        setAttached(0);
        
        //setProbabilidadCarrera(0.3);
        setIntervaloCarrera(0.3);
        tiempoActual=0.0;
        probabilidadAttachment=0.7;
        girar();
    }


    public int getM() {
        return m;
    }

    public void setM(int m) {
        this.m = m;
    }

     public double getIntervaloCarrera() {
        return intervaloCarrera;
    }

    public void setIntervaloCarrera(double t) {
        Random rnd = new Random(System.currentTimeMillis());
        double error = 0.5 * rnd.nextGaussian();
        this.intervaloCarrera = t + error;
    }

    public int getMovimientoX() {
        return movimientoX;
    }

    public void setMovimientoX(int movimientoX) {
        this.movimientoX = movimientoX;
    }

    public int getMovimientoY() {
        return movimientoY;
    }

    public void setMovimientoY(int movimientoY) {
        this.movimientoY = movimientoY;
    }

    public int getN() {
        return n;
    }

    public void setN(int n) {
        this.n = n;
    }

    public double getProbabilidadCarrera() {
        return probabilidadCarrera;
    }

    public void setProbabilidadCarrera(double probabilidadCarrera) {
        this.probabilidadCarrera = probabilidadCarrera;
    }

    public double getUltimaConcentracion() {
        return ultimaConcentracion;
    }

    public void setUltimaConcentracion(double ultimaConcentracion) {
        this.ultimaConcentracion = ultimaConcentracion;
    }
    
    public double getIncrementoCA(double dt) {
        if(attached==1)
            return REACTION_SPEED*dt;
        else
            return 0.0;
    }

    public double getProbabilidadAttachment(){
        return probabilidadAttachment;
    }

    public int getAttached() {
        return attached;
    }

    public void setAttached(int a){
        this.attached=a;
    }

    public void setState(int minX, int maxX, int minY, int maxY){
        if(x>=minX && x<=maxX && y>=minY && y<=maxY)
            {
                Random rnd = new Random();
                if (rnd.nextDouble() > getProbabilidadAttachment()) {
                    attached=1;
                }
            }
    }

    public int getX() {
        return x;
    }

    public void setX(int x) {
        this.x = x;
    }

    public int getY() {
        return y;
    }

    public void setY(int y) {
        this.y = y;
    }

    public void iterar(double dt) {

        if(attached==0)
        {
                tiempoActual+=dt;
                if (tiempoActual<intervaloCarrera)
                {
                    correr(dt);
                }else
                {
                    tiempoActual=0.0;
                    girar();
                    //System.out.println("\nGiro ");

                }
        }
     /*   Random rnd = new Random();
        if (rnd.nextDouble() < getProbabilidadCarrera()) {
            correr();
        } else {
            girar();
        }*/
    }

    private void correr(double dt) {
        int nuevaX = getX() + (int)Math.round(dt*v/cellSize)*getMovimientoX();
        int nuevaY = getY() + (int)Math.round(dt*v/cellSize)*getMovimientoY();
        if (nuevaX >= 0 && nuevaX < getM()) {
            setX(nuevaX);
        }
        if (nuevaY >= 0 && nuevaY < getN()) {
            setY(nuevaY);
        }

        comprobarMovimientoValido();
    }

    private void girar() {
        //Generamos numeros entero aleatorios entre -1 y 1
        Random rnd = new Random();
        int rX;
        int rY;
        do {
            rX = rnd.nextInt() % 2;
            rY = rnd.nextInt() % 2;
        } while (rX == 0 && rY == 0); //evitamos que gire a su posicion actual

        setMovimientoX(rX);
        setMovimientoY(rY);

        comprobarMovimientoValido();
    }

    /* La bacteria rebota si llega a una pared y sigue en ese camino*/
    private void comprobarMovimientoValido() {
        if (getX() == 0 && getMovimientoX()==-1){
                setMovimientoX(1);

        }
        if (getX() == (getM() - 1) && getMovimientoX()==1){
                setMovimientoX(-1);

        }
        if (getY() == 0 && getMovimientoY()==-1){
                setMovimientoY(1);
        }
        if (getY() == (getN() - 1) && getMovimientoY()==1){
                setMovimientoY(-1);
        }
    }

    public void comprobarConcentracion(double concentracionNueva) {
        setUltimaConcentracion(concentracionNueva);
    }

    public void calcularProbabilidadCarrera(double concentracionNueva){
        if(getUltimaConcentracion()>concentracionNueva){
            //setProbabilidadCarrera(0.3);
            setIntervaloCarrera(0.3);
          
        }else{
            setIntervaloCarrera(1.0);
            //setProbabilidadCarrera(0.8);
              //System.out.println("\nGradiente");
        }
    }
}
